'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleMute = handleMute;
exports.handleLoadStart = handleLoadStart;
exports.handleCanPlay = handleCanPlay;
exports.handleWaiting = handleWaiting;
exports.handleCanPlayThrough = handleCanPlayThrough;
exports.handlePlaying = handlePlaying;
exports.handlePlay = handlePlay;
exports.handlePause = handlePause;
exports.handleEnd = handleEnd;
exports.handleSeeking = handleSeeking;
exports.handleSeeked = handleSeeked;
exports.handleSeekingTime = handleSeekingTime;
exports.handleEndSeeking = handleEndSeeking;
exports.handleDurationChange = handleDurationChange;
exports.handleTimeUpdate = handleTimeUpdate;
exports.handleVolumeChange = handleVolumeChange;
exports.handleProgressChange = handleProgressChange;
exports.handleRateChange = handleRateChange;
var VOLUME_MUTE = exports.VOLUME_MUTE = 'video-react/VOLUME_MUTE';
var LOAD_START = exports.LOAD_START = 'video-react/LOAD_START';
var CAN_PLAY = exports.CAN_PLAY = 'video-react/CAN_PLAY';
var WAITING = exports.WAITING = 'video-react/WAITING';
var CAN_PLAY_THROUGH = exports.CAN_PLAY_THROUGH = 'video-react/CAN_PLAY_THROUGH';
var PLAYING = exports.PLAYING = 'video-react/PLAYING';
var PLAY = exports.PLAY = 'video-react/PLAY';
var PAUSE = exports.PAUSE = 'video-react/PAUSE';
var END = exports.END = 'video-react/END';
var SEEKING = exports.SEEKING = 'video-react/SEEKING';
var SEEKED = exports.SEEKED = 'video-react/SEEKED';
var SEEKING_TIME = exports.SEEKING_TIME = 'video-react/SEEKING_TIME';
var END_SEEKING = exports.END_SEEKING = 'video-react/END_SEEKING';
var DURATION_CHANGE = exports.DURATION_CHANGE = 'video-react/DURATION_CHANGE';
var TIME_UPDATE = exports.TIME_UPDATE = 'video-react/TIME_UPDATE';
var VOLUME_CHANGE = exports.VOLUME_CHANGE = 'video-react/VOLUME_CHANGE';
var PROGRESS_CHANGE = exports.PROGRESS_CHANGE = 'video-react/PROGRESS_CHANGE';
var RATE_CHANGE = exports.RATE_CHANGE = 'video-react/RATE_CHANGE';

function handleMute(muted) {
  return {
    type: VOLUME_MUTE,
    muted: muted
  };
}

function handleLoadStart(buffered) {
  return {
    type: LOAD_START,
    buffered: buffered
  };
}

function handleCanPlay(_ref) {
  var videoWidth = _ref.videoWidth,
      videoHeight = _ref.videoHeight,
      duration = _ref.duration;

  return {
    type: CAN_PLAY,
    videoWidth: videoWidth,
    videoHeight: videoHeight,
    duration: duration
  };
}

function handleWaiting() {
  return {
    type: WAITING
  };
}

function handleCanPlayThrough() {
  return {
    type: CAN_PLAY_THROUGH
  };
}

function handlePlaying() {
  return {
    type: PLAYING
  };
}

function handlePlay(_ref2) {
  var duration = _ref2.duration;

  return {
    type: PLAY,
    duration: duration
  };
}

function handlePause() {
  return {
    type: PAUSE
  };
}

function handleEnd() {
  return {
    type: END
  };
}

function handleSeeking() {
  return {
    type: SEEKING
  };
}

function handleSeeked() {
  return {
    type: SEEKED
  };
}

function handleSeekingTime(time) {
  return {
    type: SEEKING_TIME,
    time: time
  };
}

function handleEndSeeking(time) {
  return {
    type: END_SEEKING,
    time: time
  };
}

function handleDurationChange(duration) {
  return {
    type: DURATION_CHANGE,
    duration: duration
  };
}

function handleTimeUpdate(time) {
  return {
    type: TIME_UPDATE,
    time: time
  };
}

function handleVolumeChange(volume) {
  return {
    type: VOLUME_CHANGE,
    volume: volume
  };
}

function handleProgressChange(buffered) {
  return {
    type: PROGRESS_CHANGE,
    buffered: buffered
  };
}

function handleRateChange(rate) {
  return {
    type: RATE_CHANGE,
    rate: rate
  };
}